/*             CSE 687 Project 3 --- Sparse Matrix Class 

            Student Name: Gang Cheng SSN:223-61-3010               */

/*******************************************************************
 * proj3.cc ---- main program to test the member & frind functions *
 *               for class Matrix                                  *
 *******************************************************************/

#include <fstream.h> 
#include "matrix.hh"  // class Matrix

//--- <void error(char *s)> ---//
/* error handler */
void error(char *s)
{
  cerr << s; 
  exit(1);
} 

//--- < main program > ---//
/* test the member and friend functions for class Matrix */
main(int argc, char *argv[])
{
  char fname1[10], fname2[10];

  switch (argc) {
  case 1:
    cerr << "Input file name for matrix 1: ";
    cin >> fname1;
    cerr << "Input file name for matrix 2: ";
    cin >> fname2;
    break;
  case 2:
    strcpy(fname1,argv[1]);
    cerr << "Input file name for matrix 2: ";
    cin >> fname2;
    break;
  case 3:
    strcpy(fname1,argv[1]);
    strcpy(fname2,argv[2]);
    break;
  default:
    error("error: incorrect command line input\n");
    break;
  };
  
  ifstream fp1(fname1);
  ifstream fp2(fname2);
 
  // check i/o status
  if (!fp1) {
    cerr << "cannot open file: " << fname1 << "\n";
    exit(1);
  };
  if (!fp2) {
    cerr << "cannot open file: " << fname2 << "\n";
    exit(1);
  };

  // status information     
  cerr << "\nThese are files " << fname1 << " and " << fname2 << "\nProcessed by " <<  argv[0] << "\n\n";

  Matrix m1,m2;
  fp1 >> m1; fp2 >> m2;
//  int size = m1.matrix_size();
  Matrix m3(m2.matrix_size());
  cout << "\nm1 = \n"<<m1 << "\nm2 = \n" <<m2;
  cout << "\nm1 + m2 = \n" << m1 + m2;
  m3 = m1 * m2;  
  cout << "\nm1 * m2 =  \n" << m3;
  cout << "\nm1 + m1*m2  =  \n" << m1 + m1*m2;

  exit(0);

}


